/**
 * 
 */
package LPCforSOS.evaluation.losses;

import LPCforSOS.dataStructure.TwoClassConfusionMatrix;

/**
 * Calculate the false positive rate. 
 * This is defined as<p>
 * <pre>
 * incorrectly classified negatives
 * --------------------------------
 *        total negatives
 * </pre>
 *
 * @author George-P. C.F.
 *
 */
public class FpRate implements IConfusionMatrixBasedLossFunction{

	/* (non-Javadoc)
	 * @see LPCforSOS.evaluation.losses.IMultilabelCalibratedLabelRankingLossFunction#calculateLossFunction(LPCforSOS.evaluation.losses.TwoClassConfusionMatrix)
	 */
	@Override
	public double calculateLossFunction(TwoClassConfusionMatrix confusionMatrix) {
		return confusionMatrix.getFalsePositiveRate();
	}

}
