package LPCforSOS.evaluation.losses;

import LPCforSOS.dataStructure.TwoClassConfusionMatrix;

/**
 * Calculate the recall. 
 * This is defined as<p>
 * <pre>
 * correctly classified positives
 * ------------------------------
 *       total positives
 * </pre><p>
 * (Which is also the same as the truePositiveRate.)
 *
 * @author George-P. C.F.
 */
public class RecallLoss implements IConfusionMatrixBasedLossFunction{

	/* (non-Javadoc)
	 * @see LPCforSOS.evaluation.losses.IMultilabelCalibratedLabelRankingLossFunction#calculateLossFunction(LPCforSOS.evaluation.losses.TwoClassMultilabelCalibratedLabelRankingConfusionMatrix)
	 */
	@Override
	public double calculateLossFunction(TwoClassConfusionMatrix confusionMatrix) 
	{
		return confusionMatrix.getRecall();
	}

}
